# Пример создания своего провайдера

Иногда может понадобится создать свой провайдер конфигурации, это позволит использовать удобный вам синтаксис, нужно 
реализовать [ProviderInterface](../src/ProviderInterface.php).

Для примера мы хотим хранить конфигурацию в YAML вместо JSON файлов, давайте посмотрим как это можно сделать.

Будем использовать [Symfony Component Yaml](http://symfony.com/doc/current/components/yaml.html) для чтения файла YAML

```php
namespace Vendor\Package;

use Smpl\Mydi\Provider\KeyValue;
use Symfony\Component\Yaml\Yaml;

class KeyValueYaml extends KeyValue
{
    public function __construct($filePatgh)
    {
        parent::__construct(Yaml::parse($filePath));
    }
}
```

Можно просто реализовать [ProviderInterface](../src/ProviderInterface.php), если не охото расширять существующий.