# Loader Service

Это вид **загрузчиков** которые создают только один экземпляр результата (чаще всего объекта, но может быть что угодно) 
в дальнейшем один и тот же результат возвращает всегда.

Например нет смысла создавать каждый раз объект [\PDO](http://php.net/manual/ru/book.pdo.php), его можно создать один 
раз и возвращать тот же самый объект каждый раз.

Главным аргументом конструктора для создания объекта, является анонимная функция, которая первым аргументом получает 
объект **ContainerInterface** который вызвал этот самый Service.

Этот объект в анонимную функцию передается для того чтобы получать другие зависимости, например для создания **\PDO** 
нужны зависимости в виде dsn, username, password и тд.

В основном этот загрузчик может применятся в [DynamicFile provider](../provider/dynamicFile.md)

Название Service было взято из библиотеке [Pimple](http://pimple.sensiolabs.org/), также как название Factory.

[Подробные примеры использования в тестах](../../test/Loader/ServiceTest.php)