# mydi

<p align="center">
    <a href="https://travis-ci.org/smpl/mydi"><img src="https://travis-ci.org/smpl/mydi.svg?branch=master"></a>
    <a href="https://scrutinizer-ci.com/g/smpl/mydi/?branch=master"><img src="https://scrutinizer-ci.com/g/smpl/mydi/badges/quality-score.png?b=master"></a>
    <a href="https://scrutinizer-ci.com/g/smpl/mydi/?branch=master"><img src="https://scrutinizer-ci.com/g/smpl/mydi/badges/coverage.png?b=master"></a>
    <a href="https://packagist.org/packages/smpl/mydi"><img src="https://poser.pugx.org/smpl/mydi/v/stable.svg"></a>
    <a href="https://packagist.org/packages/smpl/mydi"><img src="https://poser.pugx.org/smpl/mydi/v/unstable.svg"></a>
    <a href="https://packagist.org/packages/smpl/mydi"><img src="https://poser.pugx.org/smpl/mydi/license.svg"></a>
</p>

## Особенности и преимущества

* Реализация [psr/container](https://github.com/container-interop/fig-standards/blob/master/proposed/container.md).
* Максимально строгая типизация для **PHP** и поддержка всех стабильных и актуальных релизов.
* Динамическая загрузка конфигурации (подгружается только то что надо), [подробней](doc/dynamicConfiguration.md).
* Гибкость и простота расширения, [пример создания своего провайдера](doc/customProvider.md).
* Полное покрытие тестами [phpunit](https://phpunit.de/).
* В проекте используется [семантическое версионирование](http://bfy.tw/AJ0C).
* Генерирует настройки на лету, при хорошем качестве вашего кода.

## Установка

1. Установить [composer](https://getcomposer.org/doc/00-intro.md) если ещё не установлен!
2. Выполнить:
``` 
composer require smpl/mydi @stable
``` 
3. [Ознакомиться с документацией](/doc/readme.md) или изучать на практике.

В случае обнаружению багов создавайте [issue](https://github.com/smpl/mydi/issues/new).

### Для разработчиков

* Запуск тестов:

``` 
composer test 
```

* Master ветка это ветка разработки, no rebase, rebase в feature branch не запрещен !!!

### Контакты для связи

Если у вас возникли вопросы, нужна помощь, есть идеи, вы можете создать issue или связаться со мной, 
я постараюсь вам помочь абсолютно бесплатно.

<p align="center">
    <a href="https://t.me/KuvshinovEE"><img src="https://cdn.portableapps.com/TelegramDesktopPortable_128.png"></a>
    <a href="mailto:smpl@itmywork.com"><img src="http://oit.nd.edu/assets/234560/logo_gmail_128px.png"></a>
</p>